/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Simple_P.h>



int simple_ioctl(struct inode* inode,struct file* file , unsigned int cmd, unsigned long arg )
{
  void *argp;
  int retval;
  
  DBGin("simple_ioctl");
  DBGprint(DBG_DATA,("cmd=%d",cmd));
  Simple_errno = 0;
  
  switch(cmd){

        case SETMODE:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(SetMode_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(SetMode_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(SetMode_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (SetMode_par_t *) arg, sizeof(SetMode_par_t));
              ((SetMode_par_t *) argp)->retval = simple_SetMode( inode, ((SetMode_par_t *) argp)->flags );
              ((SetMode_par_t *) argp)->error = Simple_errno;
              memcpy_toio( (SetMode_par_t *) arg, (void *) argp, sizeof(SetMode_par_t));
              kfree(argp);
              break;

  
  
  default:
    DBGout();	
    return -EINVAL;
  }
  
  

  DBGout();
  return 1;

}
