/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Submod_P.h>



int Chip1_ioctl(struct inode* inode,struct file* file , unsigned int cmd, unsigned long arg )
{
  void *argp;
  int retval;
  
  DBGin("Chip1_ioctl");
  DBGprint(DBG_DATA,("cmd=%d",cmd));
  Submod_errno = 0;
  
  switch(cmd){

        case RESET:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Reset_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Reset_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Reset_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (Reset_par_t *) arg, sizeof(Reset_par_t));
              ((Reset_par_t *) argp)->retval = Chip1_Reset( inode  );
              ((Reset_par_t *) argp)->error = Submod_errno;
              memcpy_toio( (Reset_par_t *) arg, (void *) argp, sizeof(Reset_par_t));
              kfree(argp);
              break;
      case TEST:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Test_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Test_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Test_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (Test_par_t *) arg, sizeof(Test_par_t));
              ((Test_par_t *) argp)->retval = Chip1_Test( inode, ((Test_par_t *) argp)->port );
              ((Test_par_t *) argp)->error = Submod_errno;
              memcpy_toio( (Test_par_t *) arg, (void *) argp, sizeof(Test_par_t));
              kfree(argp);
              break;
      case TEST2:
              if( verify_area(VERIFY_READ, (void *) arg, sizeof(Test2_par_t))){
                 DBGout(); return(retval); 
              }
              if( verify_area(VERIFY_WRITE, (void *) arg, sizeof(Test2_par_t))){
                 DBGout(); return(retval); 
              }
              argp = (void *) kmalloc( sizeof(Test2_par_t) +1 ,GFP_KERNEL );
              memcpy_fromio( (void *) argp, (Test2_par_t *) arg, sizeof(Test2_par_t));
              ((Test2_par_t *) argp)->retval = Chip1_Test2( inode, ((Test2_par_t *) argp)->port, 
				 ((Test2_par_t *) argp)->param );
              ((Test2_par_t *) argp)->error = Submod_errno;
              memcpy_toio( (Test2_par_t *) arg, (void *) argp, sizeof(Test2_par_t));
              kfree(argp);
              break;

  
  
  default:
    DBGout();	
    return -EINVAL;
  }
  
  

  DBGout();
  return 1;

}
