#include <rmgr_P.h>


rmgr_GetString( struct inode *inode,char *name, int len,char *sbuf )
{

#line 175 "rmgr.ddl"
		  char *buf;
		  RCS_entry entry;
		  RCS_entry *np;
                  int slen=0;
                  DBGin("GetString");
		  if( (buf = (char *) rmgr_GetFromFS((void *) name,len)) == NULL ){
                        DBGout();return -EIO;
                  }
	          DBGprint(DBG_DATA,("Lookup String name=%s",buf));
		  np = RCS_lookup(buf);
		  if( np == NULL ){
			DBGprint(DBG_DATA,("entry %s not found",buf));
			Error(-ENOTFOUND);kfree(buf);
			DBGout(); return -1;
                  }
                  kfree(buf);
		  RCS_lock(np);
                  if( ! RCS_CheckPerm(np,RCS_PERM_READ)){
			DBGprint(DBG_DATA,("read permission denied"));
			Error(-ENOPERM);
			DBGout(); return -1;
	          }				
		  if(( slen = strlen(np->uval.sval)) > 0){
                        rmgr_PutToFS(sbuf,np->uval.sval,slen);
                  }
		  RCS_unlock(np);
		  DBGout(); return slen;
	  
}
