/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <rmgr_P.h>

#line 13 "Sys.ddl"

void *rmgr_GetFromFS(void *source, unsigned long len)
{
  void *buf;
  DBGin("rmgr_GetFromFS");
   if( verify_area(VERIFY_READ,source,len) ){
	DBGprint(DBG_DATA,("verify Error"));
	DBGout();return NULL;
   }
   if(( buf = (void *) kmalloc(len+1,GFP_KERNEL) ) == NULL ){
	DBGprint(DBG_DATA,("kmalloc Error"));
	DBGout();return NULL;
   }
   memcpy_fromio( buf, source, len);
  DBGout();  return buf;
}


void rmgr_PutToFS(void *target,void *source, unsigned long len)
{
  DBGin("lddk_PutToFS");
   if( verify_area(VERIFY_WRITE,target,len) ){
	DBGprint(DBG_DATA,("verify Error"));
	DBGout();return NULL;
   }
   memcpy_toio( target, source, len);
  DBGout();
}

