#include <%<driver.name>_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

%<driver.enable-register>
%<driver.request-defs>

#ifdef LDDK_USE_REGISTER
%<driver.global-config>
%<driver.fops_struct>
#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int %<driver.name>_request ();
#endif

  DBGin("init_module");
  {
  %<driver.rmgr_init>	
  }
#ifdef LDDK_USE_REGISTER
  %<driver.register-major>
#endif
  {
    %<driver.init_code>
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[%<driver.name>_major].request_fn = %<driver.name>_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("%<driver.name> : device busy, remove delayed\n");
  }

  {
    %<driver.cleanup_code>
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[%<driver.name>_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
  %<driver.unregister-major>
#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

