#
#   
#   This Makefile has been generated with LDDK Version %<version>
#   (c) 1996 by Claus Schroeter (clausi@chemie.fu-berlin.de)
#
#
#
#
#   Creation Date: %<date>

.SILENT:

AR = ar
CFLAGS = -O6 $(INCLUDES) $(DEFS)
OBJS = %<lib.make-objects>
SRCS = %<lib.make-sources>
INCLUDES = -I. -I../include

DEFS = %<lib.make-defs>


BOLD		= "\033[1m"
NBOLD		= "\033[0m"

ECHO		= /bin/echo

COMPILE	= $(ECHO) "--- Compiling "$(BOLD)$<$(NBOLD)"..." ; gcc
DEPEND	= $(ECHO) "--- Checking dependencies..." ; gcc
RLINK	= $(ECHO) "--- Linking (relocatable) "$(BOLD)$@$(NBOLD)"..." ; ld -r
LINK	= $(ECHO) "--- Linking "$(BOLD)$@$(NBOLD)"..." ; gcc
YACC	= $(ECHO) --- Running bison on $(BOLD)$<$(NBOLD)...; bison -d -y
LEX	= $(ECHO) --- Running flex on $(BOLD)$<$(NBOLD)...; flex 
ARCHIVE = $(ECHO) --- Archiving $(BOLD)$<$(NBOLD)...; $(AR)

CC	= $(COMPILE) $(CFLAGS)


lib%<driver.name>.a : $(OBJS)
	-rm -f lib%<driver.name>.a
	$(ARCHIVE)  cr lib%<driver.name>.a $(OBJS)

#depend .depend: $(SRCS)
#	$(DEPEND) $(CFLAGS) -M $(SRCS)  >./.depend

#include .depend

clean: 
	rm *.o .depend