/***********************************************************************
 *
 *  Simple Dynamic String management routines
 *  (c) 1997 C.Schroeter (clausi@chemie.fu-berlin.de)
 *
 *
 *
 ***********************************************************************/

#ifndef _DSTRING_H_INCLUDED

typedef struct {
  char magic;
  unsigned char size;
  char *val;
} DynString;


#define DSget(a) (a->val)
#define DStrlen(a) strlen(a->val)

extern DynString * DSinit   ( void );
extern void        DSfree   ( DynString *s );
extern DynString * DScpy    ( DynString *t, DynString *s );
extern DynString * DScat    ( DynString *t, DynString *s );
extern int         DSprintf ( DynString *t, const char *format, ... );

#define _DSTRING_H_INCLUDED
#endif














