/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Simple_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1



#ifdef LDDK_USE_REGISTER
    int Simple_major = Simple_MAJOR; 
  
struct file_operations simple_fops = { 
NULL, 
simple_read, 
NULL, 
NULL, 
NULL, 
simple_ioctl, 
NULL, 
simple_open, 
simple_close, 
NULL, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int Simple_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(Simple_major,"Simple",&simple_fops) ){
      printk("can't get Major %d\n",Simple_major);
      return(-EIO);
    }
  

#endif
  {
    #line 26 "Simple.ddl"
			printk("This is a real stupid message\n");
		
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[Simple_major].request_fn = Simple_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Simple : device busy, remove delayed\n");
  }

  {
    #line 30 "Simple.ddl"
			printk("Have a nice day! \n");

		
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[Simple_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_chrdev(Simple_major,"Simple") != 0 ){
      printk("can't unregister Simple, device busy \n");
      } else {
      printk("Simple successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

