/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Submod_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1



#ifdef LDDK_USE_REGISTER
    int Submod_major = Submod_MAJOR; 
  
struct file_operations Main_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
Submod_fops_init, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int Submod_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(Submod_major,"Submod",&Main_fops) ){
      printk("can't get Major %d\n",Submod_major);
      return(-EIO);
    }
  

#endif
  {
    #line 78 "Submod.ddl" 
		  printk("** Test driver initialized\n");
		
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[Submod_major].request_fn = Submod_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Submod : device busy, remove delayed\n");
  }

  {
    #line 82 "Submod.ddl"
		 printk("** Remove Test driver\n");
		
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[Submod_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_chrdev(Submod_major,"Submod") != 0 ){
      printk("can't unregister Submod, device busy \n");
      } else {
      printk("Submod successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

