/*
* Generated with LDDK Version 0.7-beta 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Blockdev_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1

#define LDDK_USE_BLKREQUEST 1


#ifdef LDDK_USE_REGISTER
    int Blockdev_major = Blockdev_MAJOR; 
  
struct file_operations Blockdev_fops = { 
NULL, 
block_read, 
block_write, 
NULL, 
NULL, 
Blockdev_ioctl, 
NULL, 
Blockdev_open, 
Blockdev_close, 
block_fsync, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int Blockdev_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_blkdev(Blockdev_major,"Blockdev",&Blockdev_fops) ){
      printk("can't get Major %d\n",Blockdev_major);
      return(-EIO);
    }
  

#endif
  {
    #line 50 "Blockdev.ddl" 
			printk("This is a real stupid message\n");
		
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[Blockdev_major].request_fn = Blockdev_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Blockdev : device busy, remove delayed\n");
  }

  {
    #line 54 "Blockdev.ddl"
			printk("Have a nice day! \n");
		
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[Blockdev_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_blkdev(Blockdev_major,"Blockdev") != 0 ){
      printk("can't unregister Blockdev, device busy \n");
      } else {
      printk("Blockdev successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

