/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Mapping_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1



#ifdef LDDK_USE_REGISTER
    int Mapping_major = Mapping_MAJOR; 
  
struct file_operations Mapping_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
Mapping_mmap, 
Mapping_open, 
Mapping_close, 
NULL, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int Mapping_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(Mapping_major,"Mapping",&Mapping_fops) ){
      printk("can't get Major %d\n",Mapping_major);
      return(-EIO);
    }
  

#endif
  {
    #line 46 "Mapping.ddl" 

                int i;
                 
		extern char *global_message;
		printk("Maptest initialize: ");

                /*  Get one page as global 'buffer' 
                 *  This could be used for DMA or whatever
                 */

                global_message =__get_free_page(GFP_KERNEL);
		if( !global_message ){
		  printk("failed \n");
		  return 0;
		}

                /* non hardware memory must be marked as reserved since
                   otherwise mmap() will not work */

                for (i = MAP_NR (global_message); 
                      i <= MAP_NR (global_message+PAGE_SIZE-1); i++)
		    {
      			mem_map_reserve (i);
    		}

                /* now fill the buffer with garbage */
		memcpy((void *) global_message,
                      (void *) "This Is a global Message", 25 );
		printk("OK \n");
			
             
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[Mapping_major].request_fn = Mapping_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Mapping : device busy, remove delayed\n");
  }

  {
    #line 79 "Mapping.ddl"
		int i;
                extern char *global_message;

                /* unmark memory */
                for (i = MAP_NR (global_message);  
                   i <= MAP_NR (global_message+PAGE_SIZE-1); i++)
		{
                   mem_map_unreserve (i);
    		}

                if( global_message ){
		   free_page(global_message);
                }
	        printk("Have a nice day! Good bye! \n");
			
             
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[Mapping_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_chrdev(Mapping_major,"Mapping") != 0 ){
      printk("can't unregister Mapping, device busy \n");
      } else {
      printk("Mapping successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

