/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Config_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1



#ifdef LDDK_USE_REGISTER
    int Config_major = Config_MAJOR; 
  
struct file_operations Config_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
Config_open, 
Config_close, 
NULL, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int Config_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(Config_major,"Config",&Config_fops) ){
      printk("can't get Major %d\n",Config_major);
      return(-EIO);
    }
  

#endif
  {
    #line 74 "Config.ddl"			
			printk("init called Default String = '%s'\n",CONFIG_STRING);
		
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[Config_major].request_fn = Config_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Config : device busy, remove delayed\n");
  }

  {
    #line 78 "Config.ddl"
			printk("cleanup called\n");
		
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[Config_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_chrdev(Config_major,"Config") != 0 ){
      printk("can't unregister Config, device busy \n");
      } else {
      printk("Config successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

