/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Sysctl_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1



#ifdef LDDK_USE_REGISTER
    int Sysctl_major = Sysctl_MAJOR; 
  
struct file_operations Sysctl_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
Sysctl_open, 
Sysctl_close, 
NULL, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int Sysctl_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(Sysctl_major,"Sysctl",&Sysctl_fops) ){
      printk("can't get Major %d\n",Sysctl_major);
      return(-EIO);
    }
  

#endif
  {
    #line 120 "Sysctl.ddl"
			printk("init called\n");
		
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[Sysctl_major].request_fn = Sysctl_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("Sysctl : device busy, remove delayed\n");
  }

  {
    #line 124 "Sysctl.ddl"
			printk("cleanup called\n");
		
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[Sysctl_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_chrdev(Sysctl_major,"Sysctl") != 0 ){
      printk("can't unregister Sysctl, device busy \n");
      } else {
      printk("Sysctl successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

