/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <Sysctl2_P.h>
#include <linux/mm.h>
#include <linux/sysctl.h>

#define return(a) DBGout();return(a)

int OptionHandler ( ctl_table *table, int write, struct file *filp,
		    void *buffer, size_t *lenp) {
DBGin("OptionHandler");
{
#line 16 "Sysctl2.ddl" 

			int len;
                        int *val;
			char *p, c;
	                #define TMPBUFLEN 20
			char buf[TMPBUFLEN];

		        printk("Option Handler called :");

	
			if (!table->data || !table->maxlen || !*lenp ||
	    		  (filp->f_pos && !write)) {
			  *lenp = 0;
			  DBGout(); return 0;
			}
	
			val = (int *) table->data;

			if (write) {
                                printk("write");
				len = 0;
				p = buffer;
				while (len < *lenp && 
		       		(c = get_user(p++)) != 0 && c != '\n')
				len++;
			        if (len >= TMPBUFLEN)
				  len = TMPBUFLEN-1;
				memcpy_fromio(buf, buffer, len);
				buf[len]=0;                                  
				printk("buf='%s'\n",buf);

				if( buf[0] == 'o' && !strcmp(buf,"on"))
					*val = 1;
				if( buf[0] == 't' && !strcmp(buf,"true"))
					*val = 1;
				if( buf[0] == 'o' && !strcmp(buf,"off"))
					*val = 0;
				if( buf[0] == 'o' && !strcmp(buf,"false"))
					*val = 0;

			} else {
				printk("read");

				switch(*val){
				  case 0:
					sprintf(buf,"off\n");
					break;
				  case 1:
					sprintf(buf,"on\n");
					break;
				  default:
					sprintf(buf,"unknown\n");
					break;
				}
				len = *lenp;
				if (len)
					memcpy_toio(buffer, buf, strlen(buf));
				len = strlen(buf);
			
			        *lenp = len;
			        filp->f_pos += len;
			}
                        printk("\n");
			DBGout(); return 0;

                
}
DBGout();
}