#include <rmgr_P.h>


rmgr_Chmod( struct inode *inode,char *name, int len, int mode )
{

#line 99 "rmgr.ddl"
		  char *buf;
	          char *buf2;
		  RCS_entry entry;
		  RCS_entry *np;
                  DBGin("SetInt");
		  if( (buf = (char *) rmgr_GetFromFS((void *) name,len)) == NULL ){
                        DBGout();return -EIO;
                  }
	          DBGprint(DBG_DATA,("name=%s mode=0x%x",buf,mode));
		  if( (np = RCS_lookup(buf)) != NULL ){ 
		     RCS_lock(np);
                     if( ! RCS_CheckPerm(np,RCS_PERM_WRITE)){
			DBGprint(DBG_DATA,("write permission denied"));
			Error(-ENOPERM); kfree(buf);
			DBGout(); return -1;
		     }				
		     np->mflags = mode;
		     RCS_unlock(np);
                  }
		  kfree(buf);
		  DBGout(); return np->mflags;
	  
}
