#include <rmgr_P.h>


rmgr_GetInt( struct inode *inode,char *name,int len )
{

#line 301 "rmgr.ddl"
		char *buf;
		RCS_entry *np;
                DBGin("GetInt");
		if( (buf = (char *) rmgr_GetFromFS((void *) name,len)) == NULL ){
                        DBGout();return -EIO;
                }
		np = RCS_lookup(buf);
		if( np == NULL ){
			DBGprint(DBG_DATA,("entry not found"));
			Error(-ENOTFOUND);kfree(buf);
			DBGout(); return -1;
                }
                DBGprint(DBG_DATA,("name=%s int=%d",buf,np->uval.ival));
		kfree(buf);
		RCS_lock(np);
                if( ! RCS_CheckPerm(np,RCS_PERM_READ)){
			DBGprint(DBG_DATA,("read permission denied"));
			DBGout(); return -1;
		}				
                RCS_unlock(np);
		DBGout(); 
		if(np->type == RCS_INT)
			return np->uval.ival;
		else
			return *np->uval.iptr;
	  
}
