/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <rmgr_P.h>

#line 2 "destroy.ddl"

/*
 * RCS_destroy() destroy hashtable and free all allocated memory
 *
 */

int RCS_destroy() {
  int i;
  RCS_entry *np,*op;
  DBGin("RCS_destroy");
  for(i=0;i<RCS_HASHSIZE;i++) {
    for( np = RCS_hashtab[i]; np != NULL; ) {
      if( np->type == RCS_STRING && np->uval.sval != NULL )
	kfree(np->uval.sval);
      DBGprint(DBG_DATA,("destroy: %s\n",np->name));
      op = np->next; /* save pointer */
      kfree( np );
      np = op;
    }
  }
  DBGout();
}


