/*
* Generated with LDDK Version 0.7-beta2 
*     (c) 1996,1997 Claus Schroeter (clausi@chemie.fu-berlin.de) all rights reserved,
*         lddk is availiable from the Linux Lab Project
*             http://www.llp.fu-berlin.de/
*         or by anonymus FTP
*             ftp://ftp.llp.fu-berlin.de/pub/linux/LINUX-LAB/LDDK
*
*/
#include <rmgr_P.h>
#include <linux/version.h>


char kernel_version[] = UTS_RELEASE;

#define LDDK_USE_REGISTER 1



#ifdef LDDK_USE_REGISTER
    int rmgr_major = rmgr_MAJOR; 
  
struct file_operations rmgr_fops = { 
NULL, 
NULL, 
NULL, 
NULL, 
NULL, 
rmgr_ioctl, 
NULL, 
rmgr_open, 
rmgr_close, 
NULL, 
NULL, 
NULL, 
NULL 
};

#endif

#ifdef __cplusplus
extern "C" {
#endif


int init_module(void)
{
#if LDDK_USE_BLKREQUEST
  extern int rmgr_request ();
#endif

  DBGin("init_module");
  {
  	
  }
#ifdef LDDK_USE_REGISTER
      if( register_chrdev(rmgr_major,"rmgr",&rmgr_fops) ){
      printk("can't get Major %d\n",rmgr_major);
      return(-EIO);
    }
  

#endif
  {
    #line 48 "rmgr.ddl" 
	  RCS_entry *np,v;
          extern void TestCallback();
          printk("Ressource Manager initializing\n");
          RCS_init();
  
  }
#if LDDK_USE_PROCINFO
  register_procinfo();
#endif
#if LDDK_USE_SYSCTL
  register_systables();
#endif

#if LDDK_USE_BLKREQUEST
  blk_dev[rmgr_major].request_fn = rmgr_request ;
#endif

  DBGout();
  return 0;
}

void cleanup_module(void)
{
  DBGin("cleanup_module");
  if (MOD_IN_USE) {
    printk("rmgr : device busy, remove delayed\n");
  }

  {
    #line 54 "rmgr.ddl"
	printk("Ressource Manager unloading\n");
	RCS_destroy();	
  
  }



#if LDDK_USE_BLKREQUEST
  blk_dev[rmgr_major].request_fn = NULL ;
#endif
#ifdef LDDK_USE_REGISTER
        if( unregister_chrdev(rmgr_major,"rmgr") != 0 ){
      printk("can't unregister rmgr, device busy \n");
      } else {
      printk("rmgr successfully removed\n");
      }
      

#endif
#if LDDK_USE_PROCINFO
  unregister_procinfo();
#endif
#if LDDK_USE_SYSCTL
  unregister_systables();
#endif
  DBGout();
}


#ifdef __cplusplus
}
#endif

